; _____________________________________________________________________________________________________
;|****************   Modifie la i case par la valeur et renvoie la table   ***************************|
;|_____________________________________________________________________________________________________|
(define (vecteur-set! tab i val)
  (vector-set! tab i val)
  tab)

; _____________________________________________________________________________________________________
;|*****************      Aux pts de coordonnees de la liste L, mets #f dans la table      ****************|
;|_____________________________________________________________________________________________________|        
(define (effacer L table)
  (if (null? L)
      table
      (begin
        (vector-set! table (cadar L) (vecteur-set! (vector-ref table (cadar L)) (caar L) #f))
        (effacer (cdr L) table))))

; _____________________________________________________________________________________________________
;|**************      Aux pts de coordonnees de la liste L, mets #t dans la table      ****************|
;|_____________________________________________________________________________________________________|        
(define (ecrire L table)
  (if (null? L)
      table
      (begin
        (vector-set! table (cadar L) (vecteur-set! (vector-ref table (cadar L)) (caar L) #t))
        (ecrire (cdr L) table))))

; _____________________________________________________________________________________________________
;|**************************    Toute les tables deviennent vide    ***********************************|
;|_____________________________________________________________________________________________________|        
(define (Mettre_a_Zero_les_Tables table1 table2) 
  (define (aux table n)
    (if (< n 0)
        (void)
        (begin
          (vector-set! table n (list->vector (list #f #f #f #f #f #f #f #f #f #f #f)))
          (aux table (sub1 n)))))
  (aux table1 18)
  (aux table2 18))

; _____________________________________________________________________________________________________
;|***************************    Toute la table devient pleine    *************************************|
;|_____________________________________________________________________________________________________|        
(define (Mettre_que_des_blocs table)
  (define (aux table n)
    (if (< n 0)
        (void)
        (begin
          (vector-set! table n (list->vector (list #t #t #t #t #t #t #t #t #t #t #t)))
          (aux table (sub1 n)))))
  (aux table 18))

; ________________________________________________________________________________________________________
;|***************************** Afficher le tetris du joueur correspondant *******************************|
;|________________________________________________________________________________________________________|
(define blue (make-object color% 150 150 200))

(define (Affiche_Tetris dc table)
  (define (Dessine_carre table L)
    (if (> 11 (car L))
        (if (vector-ref (vector-ref table (cadr L)) (car L))
            (begin
              (send dc draw-bitmap bloc_bitmap (* (car L) 33) (* (- 14 (cadr L)) 33))
              (Dessine_carre table (list (add1 (car L)) (cadr L))))
            (begin
              (send dc draw-bitmap bitmap_carre_blanc (* (car L) 33) (* (- 14 (cadr L)) 33))
              (dessine_carre table (list (add1 (car L)) (cadr L))))))
    (void))
  (define (aux table ligne)
    (if (> 15 ligne)
        (begin
          (Dessine_carre table (list 0 ligne))
          (aux table (add1 ligne)))
        (void)))
  (aux table 0))




; _____________________________________________________________________________________________________
;|********************    Simplifie les lignes reussies dans la table    ******************************|
;|_____________________________________________________________________________________________________|        
(define (ligne_reussi? tab n)   ;  renvoie vrai si toute la ligne = #t, false sinon
  (if (= n 11)
      #t
      (and (vector-ref tab n)
           (ligne_reussi? tab (add1 n)))))

(define (Toute_la_table table n)  ;  renvoie la liste des lignes reussies
  (cond ((equal? n 15) '())
        ((ligne_reussi? (vector-ref table n) 0)  (cons n (Toute_la_table table (add1 n))))
        (else (Toute_la_table table (add1 n)))))

(define (decaler_les_lignes table rg)  ;  decale toutes les lignes du dessus d'une ligne vers le bas
  (if (= rg 15)
      (vector-set! table rg (list->vector (list #f #f #f #f #f #f #f #f #f #f #f)))
      (begin
        (vector-set! table rg (vector-ref table (add1 rg)))
        (decaler_les_lignes table (add1 rg)))))

(define (Simplifier_1player table player)
  (define (aux table L rg) ; -------------------------------  decale les lignes si il faut en enlever, de haut vers le bas
    (cond ((< rg 0) (void))
          ((null? L) (void))
          ((member rg L) (begin
                          (decaler_les_lignes table rg)
                          (aux table L (sub1 rg))))
          (else (aux table L (sub1 rg)))))
  (let ((liste_ligne (Toute_la_table table 0)))
    (aux table liste_ligne 14)
    (if (= player 1)
        (ajoute_score_et_ligne1 (length liste_ligne))
        (ajoute_score_et_ligne2 (length liste_ligne)))))

; _____________________________________________________________________________________________________
;|********************    Simplifie les lignes reussies dans la table    ******************************|
;|_____________________________________________________________________________________________________|        
(define (Simplifier_2player table player table_adverse obj obj_adverse)
  
  (define (adversaire pl)
    (if (= 1 pl) 2 1))
  
  (define (random_boolean)
    (if (zero? (random 2)) #t #f))
  
  (define (voici_une_ligne)
    (define (auxiliaire n)
      (if (zero? n)
          '()
          (cons (random_boolean) (auxiliaire (sub1 n)))))
    (auxiliaire 11))
  
  (define (decale_les_lignes_en_haut)
    (define (auxiliaire n)
      (if (zero? n)
          (void)
          (begin
            (vector-set! table_adverse n (vector-ref table_adverse (sub1 n)))
            (auxiliaire (sub1 n)))))
    (auxiliaire 15))
  
  (define (Et_de_une)
    (Decale_les_lignes_en_haut)
    (vector-set! table_adverse 0 (list->vector (voici_une_ligne))))
  
  (define (Rajouter n)
    (if (zero? n)
        (simplifier_2player table_adverse (adversaire player) table obj_adverse obj)
        (begin
          (if (not (obj_adverse 'fin table_adverse))
              (effacer (obj_adverse 'liste) table_adverse)
              (begin
                (ecrire (obj_adverse 'liste) table_adverse)
                (obj_adverse 'grimpe)))
          (Et_de_une)
          (Rajouter (sub1 n)))))

  (let ((nb_lignes (length (Toute_la_table table 0))))
    (simplifier_1player table player)
    (if (not (zero? nb_lignes))
        (if (< difficulte 6)
            (Rajouter (quotient nb_lignes difficulte))
            (Rajouter (sub1 nb_lignes)))
        (void))))